unit tunel;

INTERFACE

procedure go;

IMPLEMENTATION

uses OP386,Mode13,math,Engine3D,colors,keys,MyDOS,mem,main,MyMidas,
{$IFDEF _RLE_}
	RLEFiles
{$ELSE}
	{$IFDEF _LZ_}
	LZFiles
	{$ELSE}
	files
	{$ENDIF}
{$ENDIF}
	;

const
	TX=159;TY=99;

type
	T=array[0..TY,0..TX] of byte;

var
	x,y:^t;

procedure go;
const
	PAUSE=4;

	tunel:array[1..6] of
		record
			name:string;
			pal:Tpal;
			handle:PTexture;
		end=
		(
		(name:'PARANOIA'),
		(name:'8EP97'),
		(name:'GRANIROS'),
		(name:'ALTAQUA'),
		(name:'TILED3'),
		(name:'4EP97')
		);

var
	f:TFile;
	tex,a,l:word;
	l1,l2:byte;
	b,oc,n,da,db:integer;
	ocp:array[0..8] of boolean;
	p:^byte;
	o:P3D;
	s:TScene;
	cam:TCamera;

begin
	StartCrono;
	SetTransferMode(COPY_BLUR);

	GetMem(p,vRAMSize);
	if not LoadIMG('TB',p,tunel[1].pal) then fError('TB.IMG');

	GetMem(x,SizeOf(t));
	GetMem(y,SizeOf(t));
	if open(f,'TUNEL.BIN',RO)>0 then Ferror('TUNEL.BIN');
	read(f,x^,SizeOf(t),l);
	read(f,y^,SizeOf(t),l);
	close(f);

	for a:=1 to high(tunel) do with tunel[a] do
		if not LoadTexture(name,handle,pal) then Ferror(name+'.TEX');

	a:=1;
	with tunel[a] do
		begin
			repeat
				da:=aleatorio(-2,2);db:=aleatorio(-2,2);
			until (da<>db);
			tex:=seg(handle^);
			InkAllRGB(0,255,pal);
		end;

	if not Load3D(o,'BOLA') then Ferror('BOLA.3DN');
	SetRenderType(o,ALL_CHILDS,_TEXTURE_);
	SetTexture(o,ALL_CHILDS,tunel[a].handle);
	o^.world.z:=50000;

	NewScene(s,MAX_FACES_IN_SCENE);
	SetSceneSort(s,_NO_SORT_);
	ResetCamera(cam);

	l1:=0;l2:=0;
	l:=1;
	FillChar(ocp,SizeOf(ocp),1);
	oc:=8;

	SkipFrames:=StartFrame;
	inc(MyFrames);
	repeat
		SetCamera(s,cam);
		for n:=1 to SkipFrames do
			begin
				inc(l1,da);
				inc(l2,db);
			end;

		ASM
			PUSH		BP
			PUSH		DS
			MOV			ES,vRAM

			MOV			DL,l1
			MOV			DH,l2
			MOV			DI,0

			MOV			AX,WORD(x+2)
			DW			MOV_GS_AX

			MOV			AX,WORD(y+2)
			DW			MOV_FS_AX

			MOV			DS,tex
			MOV			BP,TY*160

			MOV			CH,TY

@Y:
			MOV			CL,TX

@X:
			XOR			AH,AH
			MOV			AL,CL

			MOV			SI,BP     						{OFFSET=m*160+n}
			ADD			SI,AX

			DB			GS;MOV		BH,[SI]     {AH=y^[m,n]}
			ADD			BH,DL                 {rota}

			DB			FS;MOV		BL,[SI]     {AL=x^[m,n]}
			ADD			BL,DH                 {z}

			MOV			AL,[BX]               {AL=texture^[AH,AL]}

			MOV			AH,AL
			MOV			ES:[DI],AX
			MOV			ES:[DI+320],AX
			ADD			DI,2

			DEC     CL
			JNZ			@X

			SUB			BP,160								{Next y^ line}
			ADD			DI,322								{Next VGA line}

			DEC			CH
			JNZ			@Y

			POP			DS
			POP			BP

			PUSH		DS
			LES			DI,PvRAM
			LDS			SI,p
			MOV			CX,64000

@BUCLE:
			MOV			AL,[SI]
			INC			SI
			TEST		AL,AL
			JZ			@CERO
			MOV			ES:[DI],AL

@CERO:
			INC			DI
			DEC			CX
			JNZ			@BUCLE
			POP			DS
		END;

		with o^ do
			begin
				if (oc>0) and (world.z>4500) then world.z:=world.z-500;

				angle.deriva:=angle.deriva+1;
				if angle.deriva>DEG then angle.deriva:=angle.deriva-DEG;

				angle.balanza:=angle.balanza+2;
				if angle.balanza>DEG then angle.balanza:=angle.balanza-DEG;

				angle.caida:=angle.caida+3;
				if angle.caida>DEG then angle.caida:=angle.caida-DEG;
			end;
		PutAll3d(s,o);
		RenderScene(s);

		if oc=0 then
			begin
				inc(l);
				b:=l mod PAUSE;
				if b=PAUSE-1 then
					WhitePal
				else
					if b=0 then
						begin
							inc(a);
							if a>high(tunel) then a:=1;
							with tunel[a] do
								begin
									tex:=seg(handle^);
									da:=aleatorio(-2,2);db:=aleatorio(-2,2);
									InkAllRGB(0,255,pal);
									SetTexture(o,ALL_CHILDS,handle);
								end;
						end;
			end
		else
			if MyFrames and 15=0 then
				begin
					repeat
						n:=random(8)+1;
					until ocp[n];
					ocp[n]:=FALSE;
					dec(oc);
				end;
			for n:=1 to 8 do
				if ocp[n] then
					if n<=4 then
						rectangle((n-1)*80,0,n*80,100,255)
					else
						rectangle((n-5)*80,100,(n-4)*80,YMAX,255);

		if inkey[K_ESC] then halt;

		rectangle(0,198,XMAX,YMAX,0);
		SkipFrames:=anima;
	until ToFinish<100;

	InkAllRGB(0,255,tunel[a].pal);
	box(0,0,XMAX,YMAX,0);
	SetTransferMode(FLAME);
	repeat
		frame;
		anima;
	until finish;

	Free3D(o);
	FreeScene(s);
	FreeMem(p,vRAMSize);
	FreeMem(x,SizeOf(t));
	FreeMem(y,SizeOf(t));
	for a:=1 to high(tunel) do FreeTexture(tunel[a].handle);
end;

end.